/**
 * \file test/namespaces.hpp
 *
 * This file is part of the Mirror library testsuite.
 *
 * Testing namespaces registration and reflection.
 *
 *  Copyright 2008 - 2010 Matus Chochlik. Distributed under the Boost
 *  Software License, Version 1.0. (See accompanying file
 *  LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 */
#ifndef MIRROR_LIBS_MIRROR_TEST_NAMESPACES_1011291729_HPP
#define MIRROR_LIBS_MIRROR_TEST_NAMESPACES_1011291729_HPP

// namespace registering
#include <mirror/meta_namespace.hpp>

namespace foo {
	namespace bar {
		namespace baz {
			namespace foobar {
			}
		}
	}
}

MIRROR_REG_BEGIN

// register foo
MIRROR_QREG_GLOBAL_SCOPE_NAMESPACE(foo)
// register foo::bar
MIRROR_QREG_NESTED_NAMESPACE(foo, bar)
// register foo::bar::baz
MIRROR_QREG_NESTED_NESTED_NAMESPACE(foo, bar, baz)
// register foo::bar::baz::foobar
MIRROR_REG_NAMESPACE_BEGIN
namespace foo { namespace bar { namespace baz {
MIRROR_REG_NAMESPACE(foobar)
} } }
MIRROR_REG_NAMESPACE_END
MIRROR_INIT_NAMESPACE_MEMBER_LIST(foo::bar::baz::foobar)


MIRROR_REG_END

#endif // include guard

